
Redmine - Defect #19731

Issue validation fails if % done field is deactivated

2015-04-28 19:36 - Dominik Brumm

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Issues Estimated time: 0.00 hour

Target version: 3.0.3   

Resolution: Fixed Affected version: 3.0.2

Description

Creating a new issue fails with a validation message "% done is not valid" when then field has been removed for the tracker.

Temporarely solved the problem by changing issue.rb:

  def clear_disabled_fields

    if tracker

      tracker.disabled_core_fields.each do |attribute|

        send "#{attribute}=", nil unless attribute == "done_ratio" 

      end

    end

  end

 
Environment:

  Redmine version                3.0.2.stable.14229

  Ruby version                   1.9.3-p484 (2013-11-22) [x86_64-linux]

  Rails version                  4.2.1

  Environment                    production

  Database adapter               Mysql2

SCM:

  Subversion                     1.8.8

  Git                            1.9.1

  Filesystem

Redmine plugins:

  no plugin installed

Related issues:

Related to Redmine - Defect #19777: Ticket update/create fails with "% Done i... Closed

Associated revisions

Revision 14241 - 2015-05-09 11:48 - Jean-Philippe Lang

Fixed that issue validation fails if % done field is deactivated (#19731).

Revision 14247 - 2015-05-10 09:19 - Jean-Philippe Lang

Merged r14241 (#19731).

History

#1 - 2015-04-29 09:24 - Toshi MARUYAMA

- Description updated

#2 - 2015-05-01 20:50 - Leonel Iturralde

Hi,

The done_ratio column is not null (mysql) in my database.

So, I change issue.rb this way

validates_inclusion_of :done_ratio, :in => 0..100, :if => Proc.new {|issue| issue.done_ratio=0 unless issue.

disabled_core_fields.include?(:done_ratio); issue.disabled_core_fields.include?(:done_ratio)}

 Hope this helps.
#3 - 2015-05-04 18:54 - Chris Tyler

Where do you make the above edit?  Does it need to be compiled?

#4 - 2015-05-05 15:08 - Leonel Iturralde

Hi,

the change is done to the file

source:tags/3.0.2/app/models/issue.rb

My change is done on the line 71.

The change done by Dominik Brumm is on the line 1591

After changing that file, restart the server.

#5 - 2015-05-08 03:23 - Go MAEDA

- Related to Defect #19777: Ticket update/create fails with "% Done is not included in the list" even when this field not enabled added

#6 - 2015-05-09 11:38 - Jean-Philippe Lang

- Target version set to 3.0.3

#7 - 2015-05-09 11:48 - Jean-Philippe Lang

- Subject changed from Validation fails if % done field is deactivated to Issue validation fails if % done field is deactivated

- Status changed from New to Resolved

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Fixed in r14241, thanks for pointing this out.

#8 - 2015-05-10 09:19 - Jean-Philippe Lang

- Status changed from Resolved to Closed
